## qhttpengine 0.1.0%2Bdfsg1

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Upstream bundles a minified copy of jQuery so we replace it with a symlink to
# the copy in libjs-jquery. The file is embedded in the binary and also copied
# to the examples directory.
JQUERY_SRC = /usr/share/javascript/jquery/jquery.min.js
JQUERY_DEST = examples/chatserver/static/js/jquery.min.js

# The test suite fails if $HOME isn't set to a valid directory
TMPDIR ?= /tmp
HOME = $(TMPDIR)

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(CURDIR)/$(JQUERY_DEST)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DOC=ON \
		-DBUILD_EXAMPLES=ON \
		-DBUILD_TESTS=ON \
		-DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH)
	ln -s $(JQUERY_SRC) $(CURDIR)/$(JQUERY_DEST)

override_dh_link:
	dh_link
	dh_link -p libqhttpengine-examples $(JQUERY_SRC) \
	    usr/lib/$(DEB_HOST_MULTIARCH)/QHttpEngine/$(JQUERY_DEST)

## qhttpengine 0.1.0+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
project(QHttpEngine)

if(NOT (CMAKE_MAJOR_VERSION VERSION_LESS 3))
    cmake_policy(SET CMP0043 OLD)
endif()

set(PROJECT_NAME "QHttpEngine")
set(PROJECT_DESCRIPTION "Simple and secure HTTP server for Qt applications")
set(PROJECT_AUTHOR "Nathan Osman")
set(PROJECT_URL "https://github.com/nitroshare/qhttpengine")

set(PROJECT_VERSION_MAJOR 0)
set(PROJECT_VERSION_MINOR 1)
set(PROJECT_VERSION_PATCH 0)
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

option(BUILD_STATIC "Build a static library" OFF)

option(BUILD_DOC "Build Doxygen documentation" OFF)
option(BUILD_EXAMPLES "Build the example applications" OFF)
option(BUILD_TESTS "Build the test suite" OFF)

set(BIN_INSTALL_DIR bin CACHE STRING "Binary runtime installation directory relative to the install prefix")
set(LIB_INSTALL_DIR lib CACHE STRING "Library installation directory relative to the install prefix")
set(INCLUDE_INSTALL_DIR include CACHE STRING "Header installation directory relative to the install prefix")
set(CMAKECONFIG_INSTALL_DIR "${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME}" CACHE STRING "CMake configuration installation directory")
set(DOC_INSTALL_DIR share/doc/${PROJECT_NAME} CACHE STRING "Documentation installation directory relative to the install prefix")
set(EXAMPLES_INSTALL_DIR "${LIB_INSTALL_DIR}/${PROJECT_NAME}/examples" CACHE STRING "Examples installation directory relative to the install prefix")

find_package(Qt5Network 5.1 REQUIRED)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

add_subdirectory(src)

if(BUILD_DOC)
    add_subdirectory(doc)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(tests)
endif()

=== doc/CMakeLists.txt ===
find_package(Doxygen REQUIRED)

configure_file(Doxyfile.in "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile")

add_custom_target(doc ALL
    "${DOXYGEN_EXECUTABLE}" "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
)

install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html"
    DESTINATION "${DOC_INSTALL_DIR}"
)

=== examples/CMakeLists.txt ===
set(EXAMPLES
    chatserver
    fileserver
)

foreach(EXAMPLE ${EXAMPLES})
    set(EXAMPLE_DIR "${EXAMPLES_INSTALL_DIR}/${EXAMPLE}")
    add_subdirectory(${EXAMPLE})
    install(DIRECTORY ${EXAMPLE}
        DESTINATION "${EXAMPLES_INSTALL_DIR}"
    )
endforeach()

=== src/CMakeLists.txt ===
file(GLOB HEADERS "${PROJECT_NAME}/*")

configure_file(qhttpengine.h.in "${CMAKE_CURRENT_BINARY_DIR}/qhttpengine.h")
set(HEADERS "${HEADERS}" "${CMAKE_CURRENT_BINARY_DIR}/qhttpengine.h")

set(SRC
    qfilesystemhandler.cpp
    qhttphandler.cpp
    qhttpparser.cpp
    qhttpserver.cpp
    qhttpsocket.cpp
    qibytearray.cpp
    qiodevicecopier.cpp
    qlocalfile.cpp
    qobjecthandler.cpp
)

if(WIN32)
    configure_file(resource.rc.in "${CMAKE_CURRENT_BINARY_DIR}/resource.rc")
    set(SRC ${SRC} "${CMAKE_CURRENT_BINARY_DIR}/resource.rc")
endif()

if(BUILD_STATIC)
    add_library(QHttpEngine STATIC ${HEADERS} ${SRC})
else()
    add_library(QHttpEngine SHARED ${HEADERS} ${SRC})
endif()

qt5_use_modules(QHttpEngine Network)

target_include_directories(QHttpEngine PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
    "$<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>"
)

set_target_properties(QHttpEngine PROPERTIES
    DEFINE_SYMBOL QT_NO_SIGNALS_SLOTS_KEYWORDS
    DEFINE_SYMBOL QHTTPENGINE_LIBRARY
    PUBLIC_HEADER "${HEADERS}"
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

install(TARGETS QHttpEngine EXPORT QHttpEngine-export
    RUNTIME DESTINATION "${BIN_INSTALL_DIR}"
    LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
    ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
    PUBLIC_HEADER DESTINATION "${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}"
)

install(EXPORT QHttpEngine-export DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE ${PROJECT_NAME}Config.cmake
)

include(CMakePackageConfigHelpers)

write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
)

configure_file(${PROJECT_NAME}.pc.in "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    DESTINATION "${LIB_INSTALL_DIR}/pkgconfig"
)

=== tests/CMakeLists.txt ===
find_package(Qt5Test 5.1 REQUIRED)

add_subdirectory(common)

set(TESTS
    TestQFilesystemHandler
    TestQHttpHandler
    TestQHttpParser
    TestQHttpServer
    TestQHttpSocket
    TestQIByteArray
    TestQIODeviceCopier
    TestQLocalFile
    TestQObjectHandler
)

foreach(TEST ${TESTS})
    add_executable(${TEST} ${TEST}.cpp)
    qt5_use_modules(${TEST} Test)
    target_link_libraries(${TEST} QHttpEngine common)
    add_test(NAME ${TEST}
        COMMAND ${TEST}
    )
endforeach()

# On Windows, the library's DLL must exist in the same directory as the test
# executables which link against it - create a custom command to copy it
if(WIN32 AND NOT BUILD_STATIC)
    add_custom_target(QHttpEngine-copy ALL
        "${CMAKE_COMMAND}" -E copy_if_different "$<TARGET_FILE:QHttpEngine>" "${CMAKE_CURRENT_BINARY_DIR}"
        DEPENDS QHttpEngine
    )
endif()

=== examples/chatserver/CMakeLists.txt ===
set(SRC
    apihandler.cpp
    main.cpp
)

qt5_add_resources(QRC resources.qrc)

add_executable(chatserver ${SRC} ${QRC})
target_link_libraries(chatserver QHttpEngine)

install(TARGETS chatserver
    RUNTIME DESTINATION "${EXAMPLE_DIR}"
)

=== examples/fileserver/CMakeLists.txt ===
set(SRC
    main.cpp
)

add_executable(fileserver ${SRC})
target_link_libraries(fileserver QHttpEngine)

install(TARGETS fileserver
    RUNTIME DESTINATION "${EXAMPLE_DIR}"
)

=== tests/common/CMakeLists.txt ===
set(SRC
    qsimplehttpclient.cpp
    qsocketpair.cpp
)

add_library(common STATIC ${SRC})
target_link_libraries(common QHttpEngine)

qt5_use_modules(common Network)

=== debian/changelog ===
qhttpengine (0.1.0+dfsg1-1mx150+1) mx; urgency=medium

  * Rebuild for MX-15.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Fri, 09 Sep 2016 13:29:22 -0700

qhttpengine (0.1.0+dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #811224)

 -- Nathan Osman <nathan@quickmediasolutions.com>  Mon, 23 May 2016 19:55:49 -0700

=== debian/control ===
Source: qhttpengine
Section: libs
Priority: extra
Maintainer: Steven Pusser (Stevo) <maintainer@mepiscommunity.org>
Bugs: mailto: maintainer@mepiscommunity.org
XSBC-Original-Maintainer: Nathan Osman <nathan@quickmediasolutions.com>
Build-Depends: debhelper (>= 9),
               cmake (>= 2.8.11),
               qtbase5-dev (>= 5.1),
               doxygen,
               libjs-jquery
Standards-Version: 3.9.8
Homepage: https://github.com/nitroshare/qhttpengine

Package: libqhttpengine0
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: HTTP server for Qt applications
 QHttpEngine provides a set of classes that enable Qt applications to create an
 HTTP server capable of serving static files and exposing a public API.
 .
 This package provides the shared library required by applications at runtime.

Package: libqhttpengine-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libqhttpengine0 (= ${binary:Version})
Description: HTTP server for Qt applications - development files
 QHttpEngine provides a set of classes that enable Qt applications to create an
 HTTP server capable of serving static files and exposing a public API.
 .
 This package provides the files necessary for developing applications that use
 the library.

Package: libqhttpengine-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         libjs-jquery
Description: HTTP server for Qt applications - documentation
 QHttpEngine provides a set of classes that enable Qt applications to create an
 HTTP server capable of serving static files and exposing a public API.
 .
 This package contains the documentation for the library.

Package: libqhttpengine-examples
Section: x11
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libjs-jquery
Description: HTTP server for Qt applications - examples
 QHttpEngine provides a set of classes that enable Qt applications to create an
 HTTP server capable of serving static files and exposing a public API.
 .
 This package provides a set of examples that use the library.
